<template>
  <div
    :class="`notification alert alert-${colorClass} ${fading ? 'fading' : ''}`"
    @mouseenter="mouseEnter"
    @mouseleave="mouseLeave"
  >
    <h4 class="alert-heading"><i :class="icon"></i>{{ title }}</h4>
    <p v-if="html === null">
      <slot>No notification text was provided</slot>
    </p>
    <p v-else v-html="html" />
    <button
      type="button"
      class="btn-close"
      aria-label="Close"
      @click="close"
    ></button>
    <div :class="`line bg-${colorClass}`"></div>
  </div>
</template>

<script>
const alertConfig = {
  error: { class: "danger", icon: "fas fa-exclamation-triangle" },
  success: { class: "success", icon: "fas fa-check-circle" },
  warning: { class: "warning", icon: "fas fa-info-circle" },
  default: { class: "danger", icon: "fas fa-exclamation-triangle" },
};

export default {
  name: "NotificationBox",
  emits: ["destroy"],
  mounted() {
    if (this.lifetime !== null) {
      setTimeout(() => {
        this.fading = true;
      }, 100);
      this.timeout = setTimeout(this.close, this.lifetime);
    }
  },
  data() {
    return {
      timeout: null,
      fading: false,
    };
  },
  props: {
    type: {
      type: String,
      default: "error",
    },
    title: {
      type: String,
      default: "Notification",
    },
    lifetime: {
      type: Number,
      default: 5000,
    },
    html: {
      type: String,
      default: null,
    },
  },
  methods: {
    close() {
      this.$emit("destroy");
    },
    mouseEnter() {
      if (this.lifetime !== null && this.timeout !== null) {
        clearTimeout(this.timeout);
        this.fading = false;
      }
    },
    mouseLeave() {
      if (this.lifetime !== null) {
        this.timeout = setTimeout(this.close, this.lifetime);
        this.fading = true;
      }
    },
  },
  computed: {
    icon() {
      if (!Object.prototype.hasOwnProperty.call(alertConfig, this.type)) {
        return alertConfig.default.icon;
      }
      return alertConfig[this.type].icon;
    },
    colorClass() {
      if (!Object.prototype.hasOwnProperty.call(alertConfig, this.type)) {
        return alertConfig.default.class;
      }
      return alertConfig[this.type].class;
    },
  },
};
</script>

<style lang="scss">
div.notification {
  pointer-events: all;
  position: relative;
  button.btn-close {
    position: absolute;
    top: 1rem;
    right: 1rem;
  }
  .line {
    max-width: 100%;
    width: 100%;
    height: 1px;
    transition: max-width 4900ms ease-out;
  }
  &.fading .line {
    max-width: 0;
  }
}
</style>
